import tempfile
import shutil
import os
import platform
import tarfile
import simplejson as json
import sys
import traceback


def path_join(*paths):
	return os.path.join(*paths)

def file_readable(path):
	return os.path.exists(path) and os.access(path, os.R_OK)
	
def create_temp_dir():
	return tempfile.mkdtemp()

def create_temp_file():
	return tempfile.mktemp()

def make_dirs(d):
	if not os.path.exists(d):
		os.makedirs(d)

def make_symlink(target, path):
	os.symlink(target, path)

def copy_file(src, dst):
	shutil.copy(src, dst)

def copy_fileobj_to_temp(f):
	tmpFileName = create_temp_file()
	tmpFile = open(tmpFileName, 'w')
	shutil.copyfileobj(f, tmpFile)
	tmpFile.flush()
	tmpFile.close()
	return tmpFileName

def copy_tree(src, dst):
	shutil.copytree(src, dst)

def list_dir(path):
	return os.listdir(path)

def get_distribution_id():
	return platform.dist()[0]

def load_json(filePath):
	f = open(filePath)
	o = json.load(f)
	f.close()
	return o

def load_json_file(f):
	return json.load(f)

def tar_extract(tarFilePath, dest):
	pkg = tarfile.open(tarFilePath)
	pkg.extractall(dest)
	return

def print_traceback():
	traceback.print_exc()

def compare_version_string(v1, v2):
	v1x = tuple(map(int, (v1.split("."))))
	v2x = tuple(map(int, (v2.split("."))))
	if v1x > v2x:
		return -1
	if v1x < v2x:
		return 1
	return 0
